import processing.sound.*;

FFT fft;     //Frequency Spectrum
AudioIn in;  //Audio Input stream
int bands = 512; //Numbers of channels
float[] spectrum = new float[bands];

void setup() {
  size(500, 500);

  // Create an Audio Input stream
  in = new AudioIn(this, 0);
  in.start();

  // get the frequency spectrum of the input stream
  fft = new FFT(this, bands);
  fft.input(in);
}

void draw() {
  //simulating the persistence of vision
  fill(255, 10);
  rect(0, 0, width, height);
  
  //calculate the frequency spectrum
  fft.analyze(spectrum); 
  
  //draw the first 16 frequency spectrum
  for (int i = 0; i < 16; i++) {
    fill(0);
    rect(i*32, height - spectrum[i]*height*5, 32, spectrum[i]*height*5);
  }
  
  //draw the full frequency spectrum
  //for (int i = 0; i < bands; i++) {
  //  stroke(0);
  //  line( i, height, i, height - spectrum[i]*height*5 );
  //}
  
}